<?php

namespace EventPortal\Http\Controllers\Admin\Email;

use EventPortal\Domain\Email\Models\EventEmail;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Util\Notification\Facades\Notification;
use EventPortal\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;

class SendEventEmailController extends Controller
{
    public function __construct()
    {
        $this->middleware('check-permission:email.store');
    }

    public function __invoke(Event $event, EventEmail $email): RedirectResponse
    {
        Notification::make($email->getNotificationKey())
            ->to($event->delegates->pluck('user'))
            ->event($event)
            ->send();

        toast()->success(trans('email.sent'));

        return redirect()->back();
    }
}
