<?php

namespace EventPortal\Http\Controllers\Delegate\Event;

use EventPortal\Domain\Component\Button;
use EventPortal\Domain\Event\Models\Event;
use EventPortal\Domain\Event\ValueObjects\EventDetails;
use EventPortal\Domain\Event\ValueObjects\PageHeader;
use EventPortal\Domain\Util\DelegateRender;
use EventPortal\Enums\InertiaMethod;
use EventPortal\Http\Controllers\Controller;
use Inertia\Response;

class LandingController extends Controller
{
    public function __invoke(Event $event): Response
    {
        $callToAction = Button::make('Go To Dashboard')
            ->method(InertiaMethod::VISIT())
            ->route('home');

        return DelegateRender::component('Delegate/Landing/Index')
            ->withPageHeader(
                PageHeader::make()
                    ->title('Landing')
                    ->description('Lorem ipsum dolor sit amet, consectetur adipiscing elit.')
                    ->callToAction($callToAction)
            )
            ->withEventDetails(EventDetails::make($event))
            ->get();
    }
}
